Index: tests/regression/Selection/Atoms/AllAtoms/testsuite-selection-unselect-all-atoms.at
===================================================================
--- tests/regression/Selection/Atoms/AllAtoms/testsuite-selection-unselect-all-atoms.at	(revision f2872ae885ed8ca989001542d272c75794be73c1)
+++ tests/regression/Selection/Atoms/AllAtoms/testsuite-selection-unselect-all-atoms.at	(revision 43a0aebcbd9fa87981dbf5339765fb0804d755c8)
@@ -3,5 +3,5 @@
 
 AT_SETUP([Unselection - All Atoms])
-AT_KEYWORDS([selection])
+AT_KEYWORDS([unselection])
 
 file=box.xyz
@@ -15,5 +15,5 @@
 
 AT_SETUP([Unselection - All Atoms with Undo])
-AT_KEYWORDS([selection])
+AT_KEYWORDS([unselection])
 
 file=id0_missing.xyz
@@ -27,5 +27,5 @@
 
 AT_SETUP([Unselection - All Atoms with Redo])
-AT_KEYWORDS([selection])
+AT_KEYWORDS([unselection])
 
 file=box.xyz
Index: tests/regression/Selection/Atoms/AllAtomsOfMolecule/testsuite-selection-unselect-all-atoms-of-molecule.at
===================================================================
--- tests/regression/Selection/Atoms/AllAtomsOfMolecule/testsuite-selection-unselect-all-atoms-of-molecule.at	(revision f2872ae885ed8ca989001542d272c75794be73c1)
+++ tests/regression/Selection/Atoms/AllAtomsOfMolecule/testsuite-selection-unselect-all-atoms-of-molecule.at	(revision 43a0aebcbd9fa87981dbf5339765fb0804d755c8)
@@ -3,5 +3,5 @@
 
 AT_SETUP([Unselection - All atoms of selected molecules])
-AT_KEYWORDS([selection])
+AT_KEYWORDS([unselection])
 
 file=molecule0.xyz
@@ -21,5 +21,5 @@
 
 AT_SETUP([Unselection - All atoms of selected molecules with Undo])
-AT_KEYWORDS([selection])
+AT_KEYWORDS([unselection])
 
 file=molecule0.xyz
@@ -39,5 +39,5 @@
 
 AT_SETUP([Unselection - All atoms of selected molecules with Redo])
-AT_KEYWORDS([selection])
+AT_KEYWORDS([unselection])
 
 file=molecule0.xyz
Index: tests/regression/Selection/Atoms/AtomByElement/testsuite-selection-unselect-atoms-by-element.at
===================================================================
--- tests/regression/Selection/Atoms/AtomByElement/testsuite-selection-unselect-atoms-by-element.at	(revision f2872ae885ed8ca989001542d272c75794be73c1)
+++ tests/regression/Selection/Atoms/AtomByElement/testsuite-selection-unselect-atoms-by-element.at	(revision 43a0aebcbd9fa87981dbf5339765fb0804d755c8)
@@ -4,5 +4,5 @@
 # select element by atomic number: 1, 4
 AT_SETUP([Unselection - All atoms with specific element by atomic number])
-AT_KEYWORDS([selection,atom,element,atomic number])
+AT_KEYWORDS([unselection,atom,element,atomic number])
 
 file=test-H_present.xyz
Index: tests/regression/Selection/Atoms/AtomById/testsuite-selection-unselect-atom-by-id.at
===================================================================
--- tests/regression/Selection/Atoms/AtomById/testsuite-selection-unselect-atom-by-id.at	(revision f2872ae885ed8ca989001542d272c75794be73c1)
+++ tests/regression/Selection/Atoms/AtomById/testsuite-selection-unselect-atom-by-id.at	(revision 43a0aebcbd9fa87981dbf5339765fb0804d755c8)
@@ -3,5 +3,5 @@
 
 AT_SETUP([Unselection - atom with specific id])
-AT_KEYWORDS([selection,id,atom])
+AT_KEYWORDS([unselection,id,atom])
 # go through all possible ids (0-7) and remove others
 i=0
@@ -19,5 +19,5 @@
 
 AT_SETUP([Unselection - atom with specific id with Undo])
-AT_KEYWORDS([selection,id,atom])
+AT_KEYWORDS([unselection,id,atom])
 # go through all possible ids (0-7) and remove others
 i=0
@@ -35,5 +35,5 @@
 
 AT_SETUP([Unselection - atom with specific id with Redo])
-AT_KEYWORDS([selection,id,atom])
+AT_KEYWORDS([unselection,id,atom])
 # go through all possible ids (0-7) and remove others
 i=0
Index: tests/regression/Selection/Atoms/AtomsInsideCuboid/testsuite-selection-unselect-atoms-inside-cuboid.at
===================================================================
--- tests/regression/Selection/Atoms/AtomsInsideCuboid/testsuite-selection-unselect-atoms-inside-cuboid.at	(revision f2872ae885ed8ca989001542d272c75794be73c1)
+++ tests/regression/Selection/Atoms/AtomsInsideCuboid/testsuite-selection-unselect-atoms-inside-cuboid.at	(revision 43a0aebcbd9fa87981dbf5339765fb0804d755c8)
@@ -3,5 +3,5 @@
 
 AT_SETUP([Unselection - All atoms inside cuboid])
-AT_KEYWORDS([selection,cuboid])
+AT_KEYWORDS([unselection,cuboid])
 
 file=allatomsinsidecuboid.xyz
@@ -24,5 +24,5 @@
 
 AT_SETUP([Unselection - All atoms inside cuboid with Undo])
-AT_KEYWORDS([selection,cuboid])
+AT_KEYWORDS([unselection,cuboid])
 
 file=allatomsinsidecuboid.xyz
@@ -36,5 +36,5 @@
 
 AT_SETUP([Unselection - All atoms inside cuboid with Redo])
-AT_KEYWORDS([selection,cuboid])
+AT_KEYWORDS([unselection,cuboid])
 
 file=allatomsinsidecuboid.xyz
Index: tests/regression/Selection/Atoms/AtomsInsideSphere/testsuite-selection-unselect-atoms-inside-sphere.at
===================================================================
--- tests/regression/Selection/Atoms/AtomsInsideSphere/testsuite-selection-unselect-atoms-inside-sphere.at	(revision f2872ae885ed8ca989001542d272c75794be73c1)
+++ tests/regression/Selection/Atoms/AtomsInsideSphere/testsuite-selection-unselect-atoms-inside-sphere.at	(revision 43a0aebcbd9fa87981dbf5339765fb0804d755c8)
@@ -3,5 +3,5 @@
 
 AT_SETUP([Unselection - All atoms inside sphere])
-AT_KEYWORDS([selection,sphere])
+AT_KEYWORDS([unselection,sphere])
 
 file=allatomsinsidesphere.xyz
@@ -24,5 +24,5 @@
 
 AT_SETUP([Unselection - All atoms inside sphere with Undo])
-AT_KEYWORDS([selection,sphere])
+AT_KEYWORDS([unselection,sphere])
 
 file=allatomsinsidesphere.xyz
@@ -36,5 +36,5 @@
 
 AT_SETUP([Unselection - All atoms inside sphere with Redo])
-AT_KEYWORDS([selection,sphere])
+AT_KEYWORDS([unselection,sphere])
 
 file=allatomsinsidesphere.xyz