Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 24da485f43375167b5cf182eca27274ba36aeb39)
+++ src/Actions/Makefile.am	(revision 48d3c04f127648994f9bb992902f82fdf27e06e4)
@@ -12,6 +12,6 @@
   Actions/ManipulateAtomsProcess.cpp \
   Actions/MethodAction.cpp \
-	Actions/OptionRegistry.cpp \
-	Actions/OptionTrait.cpp \
+  Actions/OptionRegistry.cpp \
+  Actions/OptionTrait.cpp \
   Actions/Process.cpp \
   Actions/Values.cpp \
@@ -23,4 +23,5 @@
   Actions/Action_impl_header.hpp \
   Actions/Action_impl_pre.hpp \
+  Actions/Action_impl_undef.hpp \
   Actions/ActionHistory.hpp \
   Actions/ActionRegistry.hpp \
@@ -33,9 +34,10 @@
   Actions/Calculation_impl.hpp \
   Actions/ErrorAction.hpp \
+  Actions/GlobalListOfActions.hpp \
   Actions/MakroAction.hpp \
   Actions/ManipulateAtomsProcess.hpp \
   Actions/MethodAction.hpp \
-	Actions/OptionRegistry.hpp \
-	Actions/OptionTrait.hpp \
+  Actions/OptionRegistry.hpp \
+  Actions/OptionTrait.hpp \
   Actions/Process.hpp \
   Actions/Reaction.hpp \
@@ -44,5 +46,5 @@
   Actions/Reaction_impl_pre.hpp \
   Actions/Values.hpp \
- 	Actions/ValueStorage.hpp
+  Actions/ValueStorage.hpp
   
 ACTIONPROTOTYPESSOURCE = \
@@ -261,98 +263,98 @@
 
 RANDONNUMBERSSOURCE =\
-	Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.cpp \
-	Actions/RandomNumbersAction/SetRandomNumbersEngineAction.cpp
+  Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.cpp \
+  Actions/RandomNumbersAction/SetRandomNumbersEngineAction.cpp
 RANDONNUMBERSHEADER =\
-	Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.hpp \
-	Actions/RandomNumbersAction/SetRandomNumbersEngineAction.hpp
+  Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.hpp \
+  Actions/RandomNumbersAction/SetRandomNumbersEngineAction.hpp
 RANDONNUMBERSDEFS =\
-	Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.def \
-	Actions/RandomNumbersAction/SetRandomNumbersEngineAction.def
+  Actions/RandomNumbersAction/SetRandomNumbersDistributionAction.def \
+  Actions/RandomNumbersAction/SetRandomNumbersEngineAction.def
                  
 SELECTIONATOMACTIONSOURCE = \
-	Actions/SelectionAction/Atoms/AllAtomsAction.cpp \
-	Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp \
-	Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp \
-	Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.cpp \
-	Actions/SelectionAction/Atoms/AtomByElementAction.cpp \
-	Actions/SelectionAction/Atoms/AtomByIdAction.cpp \
-	Actions/SelectionAction/Atoms/ClearAllAtomsAction.cpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsAction.cpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.cpp \
-	Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp \
-	Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp
+  Actions/SelectionAction/Atoms/AllAtomsAction.cpp \
+  Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.cpp \
+  Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.cpp \
+  Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.cpp \
+  Actions/SelectionAction/Atoms/AtomByElementAction.cpp \
+  Actions/SelectionAction/Atoms/AtomByIdAction.cpp \
+  Actions/SelectionAction/Atoms/ClearAllAtomsAction.cpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsAction.cpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.cpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.cpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.cpp \
+  Actions/SelectionAction/Atoms/NotAtomByElementAction.cpp \
+  Actions/SelectionAction/Atoms/NotAtomByIdAction.cpp
 SELECTIONATOMACTIONHEADER = \
-	Actions/SelectionAction/Atoms/AllAtomsAction.hpp \
-	Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.hpp \
-	Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.hpp \
-	Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.hpp \
-	Actions/SelectionAction/Atoms/AtomByElementAction.hpp \
-	Actions/SelectionAction/Atoms/AtomByIdAction.hpp \
-	Actions/SelectionAction/Atoms/ClearAllAtomsAction.hpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsAction.hpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.hpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.hpp \
-	Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.hpp \
-	Actions/SelectionAction/Atoms/NotAtomByElementAction.hpp \
-	Actions/SelectionAction/Atoms/NotAtomByIdAction.hpp
+  Actions/SelectionAction/Atoms/AllAtomsAction.hpp \
+  Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.hpp \
+  Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.hpp \
+  Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.hpp \
+  Actions/SelectionAction/Atoms/AtomByElementAction.hpp \
+  Actions/SelectionAction/Atoms/AtomByIdAction.hpp \
+  Actions/SelectionAction/Atoms/ClearAllAtomsAction.hpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsAction.hpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.hpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.hpp \
+  Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.hpp \
+  Actions/SelectionAction/Atoms/NotAtomByElementAction.hpp \
+  Actions/SelectionAction/Atoms/NotAtomByIdAction.hpp
 SELECTIONATOMACTIONDEFS = \
-	Actions/SelectionAction/Atoms/AllAtomsAction.def \
-	Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.def \
-	Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.def \
-	Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.def \
-	Actions/SelectionAction/Atoms/AtomByElementAction.def \
-	Actions/SelectionAction/Atoms/AtomByIdAction.def \
-	Actions/SelectionAction/Atoms/ClearAllAtomsAction.def \
-	Actions/SelectionAction/Atoms/NotAllAtomsAction.def \
-	Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.def \
-	Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.def \
-	Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.def \
-	Actions/SelectionAction/Atoms/NotAtomByElementAction.def \
-	Actions/SelectionAction/Atoms/NotAtomByIdAction.def
+  Actions/SelectionAction/Atoms/AllAtomsAction.def \
+  Actions/SelectionAction/Atoms/AllAtomsInsideCuboidAction.def \
+  Actions/SelectionAction/Atoms/AllAtomsInsideSphereAction.def \
+  Actions/SelectionAction/Atoms/AllAtomsOfMoleculeAction.def \
+  Actions/SelectionAction/Atoms/AtomByElementAction.def \
+  Actions/SelectionAction/Atoms/AtomByIdAction.def \
+  Actions/SelectionAction/Atoms/ClearAllAtomsAction.def \
+  Actions/SelectionAction/Atoms/NotAllAtomsAction.def \
+  Actions/SelectionAction/Atoms/NotAllAtomsInsideCuboidAction.def \
+  Actions/SelectionAction/Atoms/NotAllAtomsInsideSphereAction.def \
+  Actions/SelectionAction/Atoms/NotAllAtomsOfMoleculeAction.def \
+  Actions/SelectionAction/Atoms/NotAtomByElementAction.def \
+  Actions/SelectionAction/Atoms/NotAtomByIdAction.def
 
 SELECTIONMOLECULEACTIONSOURCE = \
-	Actions/SelectionAction/Molecules/AllMoleculesAction.cpp \
-	Actions/SelectionAction/Molecules/ClearAllMoleculesAction.cpp \
-	Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp \
-	Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp \
-	Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp \
-	Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp \
-	Actions/SelectionAction/Molecules/MoleculeOfAtomAction.cpp \
-	Actions/SelectionAction/Molecules/NotAllMoleculesAction.cpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp \
-	Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.cpp
+  Actions/SelectionAction/Molecules/AllMoleculesAction.cpp \
+  Actions/SelectionAction/Molecules/ClearAllMoleculesAction.cpp \
+  Actions/SelectionAction/Molecules/MoleculeByFormulaAction.cpp \
+  Actions/SelectionAction/Molecules/MoleculeByIdAction.cpp \
+  Actions/SelectionAction/Molecules/MoleculeByNameAction.cpp \
+  Actions/SelectionAction/Molecules/MoleculeByOrderAction.cpp \
+  Actions/SelectionAction/Molecules/MoleculeOfAtomAction.cpp \
+  Actions/SelectionAction/Molecules/NotAllMoleculesAction.cpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp \
+  Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.cpp
 SELECTIONMOLECULEACTIONHEADER = \
-	Actions/SelectionAction/Molecules/AllMoleculesAction.hpp \
-	Actions/SelectionAction/Molecules/ClearAllMoleculesAction.hpp \
-	Actions/SelectionAction/Molecules/MoleculeByFormulaAction.hpp \
-	Actions/SelectionAction/Molecules/MoleculeByIdAction.hpp \
-	Actions/SelectionAction/Molecules/MoleculeByNameAction.hpp \
-	Actions/SelectionAction/Molecules/MoleculeByOrderAction.hpp \
-	Actions/SelectionAction/Molecules/MoleculeOfAtomAction.hpp \
-	Actions/SelectionAction/Molecules/NotAllMoleculesAction.hpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.hpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByIdAction.hpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByNameAction.hpp \
-	Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.hpp \
-	Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.hpp
+  Actions/SelectionAction/Molecules/AllMoleculesAction.hpp \
+  Actions/SelectionAction/Molecules/ClearAllMoleculesAction.hpp \
+  Actions/SelectionAction/Molecules/MoleculeByFormulaAction.hpp \
+  Actions/SelectionAction/Molecules/MoleculeByIdAction.hpp \
+  Actions/SelectionAction/Molecules/MoleculeByNameAction.hpp \
+  Actions/SelectionAction/Molecules/MoleculeByOrderAction.hpp \
+  Actions/SelectionAction/Molecules/MoleculeOfAtomAction.hpp \
+  Actions/SelectionAction/Molecules/NotAllMoleculesAction.hpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.hpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByIdAction.hpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByNameAction.hpp \
+  Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.hpp \
+  Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.hpp
 SELECTIONMOLECULEACTIONDEFS = \
-	Actions/SelectionAction/Molecules/AllMoleculesAction.def \
-	Actions/SelectionAction/Molecules/ClearAllMoleculesAction.def \
-	Actions/SelectionAction/Molecules/MoleculeByFormulaAction.def \
-	Actions/SelectionAction/Molecules/MoleculeByIdAction.def \
-	Actions/SelectionAction/Molecules/MoleculeByNameAction.def \
-	Actions/SelectionAction/Molecules/MoleculeByOrderAction.def \
-	Actions/SelectionAction/Molecules/MoleculeOfAtomAction.def \
-	Actions/SelectionAction/Molecules/NotAllMoleculesAction.def \
-	Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.def \
-	Actions/SelectionAction/Molecules/NotMoleculeByIdAction.def \
-	Actions/SelectionAction/Molecules/NotMoleculeByNameAction.def \
-	Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.def \
-	Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.def
+  Actions/SelectionAction/Molecules/AllMoleculesAction.def \
+  Actions/SelectionAction/Molecules/ClearAllMoleculesAction.def \
+  Actions/SelectionAction/Molecules/MoleculeByFormulaAction.def \
+  Actions/SelectionAction/Molecules/MoleculeByIdAction.def \
+  Actions/SelectionAction/Molecules/MoleculeByNameAction.def \
+  Actions/SelectionAction/Molecules/MoleculeByOrderAction.def \
+  Actions/SelectionAction/Molecules/MoleculeOfAtomAction.def \
+  Actions/SelectionAction/Molecules/NotAllMoleculesAction.def \
+  Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.def \
+  Actions/SelectionAction/Molecules/NotMoleculeByIdAction.def \
+  Actions/SelectionAction/Molecules/NotMoleculeByNameAction.def \
+  Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.def \
+  Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.def
 	
 TESSELATIONACTIONSOURCE = \