Index: src/Actions/CmdAction/VersionAction.cpp
===================================================================
--- src/Actions/CmdAction/VersionAction.cpp	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
+++ src/Actions/CmdAction/VersionAction.cpp	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
@@ -0,0 +1,66 @@
+/*
+ * VersionAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/CmdAction/VersionAction.hpp"
+#include "CommandLineParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+
+const char CommandLineVersionAction::NAME[] = "version";
+
+CommandLineVersionAction::CommandLineVersionAction() :
+  Action(NAME)
+{}
+
+CommandLineVersionAction::~CommandLineVersionAction()
+{}
+
+Action::state_ptr CommandLineVersionAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryEmpty(NAME, ESPACKVersion);
+
+  if(dialog->display()) {
+    delete dialog;
+    return Action::success;
+  } else {
+    delete dialog;
+    return Action::failure;
+  }
+}
+
+Action::state_ptr CommandLineVersionAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr CommandLineVersionAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool CommandLineVersionAction::canUndo() {
+  return false;
+}
+
+bool CommandLineVersionAction::shouldUndo() {
+  return false;
+}
+
+const string CommandLineVersionAction::getName() {
+  return NAME;
+}
Index: src/Actions/CmdAction/VersionAction.hpp
===================================================================
--- src/Actions/CmdAction/VersionAction.hpp	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
+++ src/Actions/CmdAction/VersionAction.hpp	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
@@ -0,0 +1,31 @@
+/*
+ * VersionAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef VERSIONACTION_HPP_
+#define VERSIONACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include "version.h"
+
+class CommandLineVersionAction : public Action {
+public:
+  CommandLineVersionAction();
+  virtual ~CommandLineVersionAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* VERSIONACTION_HPP_ */
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 86466e070d1b66f70981d199068ca4eb345320b0)
+++ src/Makefile.am	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
@@ -89,7 +89,9 @@
 
 CMDACTIONSOURCE = \
-  Actions/CmdAction/HelpAction.cpp
+  Actions/CmdAction/HelpAction.cpp \
+  Actions/CmdAction/VersionAction.cpp
 CMDACTIONHEADER = \
-  Actions/CmdAction/HelpAction.hpp
+  Actions/CmdAction/HelpAction.hpp \
+  Actions/CmdAction/VersionAction.hpp
 
 FRAGMENTATIONACTIONSOURCE = 
Index: src/UIElements/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineWindow.cpp	(revision 86466e070d1b66f70981d199068ca4eb345320b0)
+++ src/UIElements/CommandLineWindow.cpp	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
@@ -13,4 +13,5 @@
 #include "Actions/ActionRegistry.hpp"
 #include "Actions/CmdAction/HelpAction.hpp"
+#include "Actions/CmdAction/VersionAction.hpp"
 #include "Actions/ParserAction/LoadXyzAction.hpp"
 #include "Actions/ParserAction/SaveXyzAction.hpp"
@@ -25,5 +26,10 @@
 {
   // create and register all command line callable actions
+  populateAtomActions();
+  populateCmdActions();
+  populateFragmentationActions();
+  populateMoleculeActions();
   populateParserActions();
+  populateTesselationActions();
 
   // Add status indicators etc...
@@ -46,9 +52,30 @@
 }
 
+void CommandLineWindow::populateAtomActions()
+{
+}
+
+void CommandLineWindow::populateCmdActions()
+{
+  new CommandLineHelpAction();
+  new CommandLineVersionAction();
+}
+
+void CommandLineWindow::populateFragmentationActions()
+{
+}
+
+void CommandLineWindow::populateMoleculeActions()
+{
+}
+
 void CommandLineWindow::populateParserActions()
 {
-  new CommandLineHelpAction();
   new ParserLoadXyzAction();
   new ParserSaveXyzAction();
 }
 
+void CommandLineWindow::populateTesselationActions()
+{
+}
+
Index: src/UIElements/CommandLineWindow.hpp
===================================================================
--- src/UIElements/CommandLineWindow.hpp	(revision 86466e070d1b66f70981d199068ca4eb345320b0)
+++ src/UIElements/CommandLineWindow.hpp	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
@@ -23,5 +23,10 @@
 private:
   // populaters
+  void populateAtomActions();
+  void populateCmdActions();
+  void populateFragmentationActions();
+  void populateMoleculeActions();
   void populateParserActions();
+  void populateTesselationActions();
 
   CommandLineStatusIndicator *statusIndicator;
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 86466e070d1b66f70981d199068ca4eb345320b0)
+++ src/builder.cpp	(revision 50dfdae6d8f0ccc9165dcc2f73a1adcd35dd66e1)
@@ -2547,4 +2547,5 @@
       CommandLineParser::getInstance().generic.add_options()
           ("help,h", "produce help message")
+          ("version,v", "show version")
           ("parse-xyz,p", po::value< vector<string> >(), "parse xyz file into World")
           ;