Index: tests/regression/Graph/CreateAdjacency/post/ethane-half.pdb
===================================================================
--- tests/regression/Graph/CreateAdjacency/post/ethane-half.pdb	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
+++ tests/regression/Graph/CreateAdjacency/post/ethane-half.pdb	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
@@ -0,0 +1,13 @@
+REMARK created by molecuilder on Fri Mar  1 19:45:11 2013, time step 0
+ATOM      1 C01 0eth 01          3.125  10.442  10.000  0.00  0.00           C 0
+ATOM      2 C02 0eth 01          4.374   9.559  10.000  0.00  0.00           C 0
+ATOM      3 H01 0eth 01          3.125  11.071   9.110  0.00  0.00           H 0
+ATOM      4 H02 0eth 01          3.125  11.071  10.890  0.00  0.00           H 0
+ATOM      5 H03 0eth 01          4.374   8.929   9.110  0.00  0.00           H 0
+ATOM      6 H04 0eth 01          4.374   8.929  10.890  0.00  0.00           H 0
+ATOM      7 H05 0eth 01          2.235   9.813  10.000  0.00  0.00           H 0
+ATOM      8 H06 0eth 01          5.264  10.188  10.000  0.00  0.00           H 0
+CONECT    5    2                                                                
+CONECT    6    2                                                                
+CONECT    8    2                                                                
+END
Index: tests/regression/Graph/CreateAdjacency/post/ethane.pdb
===================================================================
--- tests/regression/Graph/CreateAdjacency/post/ethane.pdb	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
+++ tests/regression/Graph/CreateAdjacency/post/ethane.pdb	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
@@ -0,0 +1,18 @@
+REMARK created by molecuilder on Fri Mar  1 19:45:11 2013, time step 0
+ATOM      1 C01 0eth 01          3.125  10.442  10.000  0.00  0.00           C 0
+ATOM      2 C02 0eth 01          4.374   9.559  10.000  0.00  0.00           C 0
+ATOM      3 H01 0eth 01          3.125  11.071   9.110  0.00  0.00           H 0
+ATOM      4 H02 0eth 01          3.125  11.071  10.890  0.00  0.00           H 0
+ATOM      5 H03 0eth 01          4.374   8.929   9.110  0.00  0.00           H 0
+ATOM      6 H04 0eth 01          4.374   8.929  10.890  0.00  0.00           H 0
+ATOM      7 H05 0eth 01          2.235   9.813  10.000  0.00  0.00           H 0
+ATOM      8 H06 0eth 01          5.264  10.188  10.000  0.00  0.00           H 0
+CONECT    1    2    3    4    7                                                 
+CONECT    2    1    5    6    8                                                 
+CONECT    3    1                                                                
+CONECT    4    1                                                                
+CONECT    5    2                                                                
+CONECT    6    2                                                                
+CONECT    7    1                                                                
+CONECT    8    2                                                                
+END
Index: tests/regression/Graph/CreateAdjacency/pre/ethane.xyz
===================================================================
--- tests/regression/Graph/CreateAdjacency/pre/ethane.xyz	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
+++ tests/regression/Graph/CreateAdjacency/pre/ethane.xyz	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
@@ -0,0 +1,10 @@
+8
+	Created by molecuilder on Fri Mar  1 19:45:11 2013, time step 0
+C	3.125	10.442	10.000
+C	4.374	9.559	10.000
+H	3.125	11.071	9.110
+H	3.125	11.071	10.890
+H	4.374	8.929	9.110
+H	4.374	8.929	10.890
+H	2.235	9.813	10.000
+H	5.264	10.188	10.000
Index: tests/regression/Graph/CreateAdjacency/testsuite-graph-create-adjacency.at
===================================================================
--- tests/regression/Graph/CreateAdjacency/testsuite-graph-create-adjacency.at	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
+++ tests/regression/Graph/CreateAdjacency/testsuite-graph-create-adjacency.at	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
@@ -0,0 +1,78 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2008-2012 University of Bonn
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### create adjacency
+
+AT_SETUP([Graph - create adjacency])
+AT_KEYWORDS([graph create-adjacency])
+
+file=ethane.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Graph/CreateAdjacency/pre/ethane.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -o pdb --select-all-atoms --create-adjacency], 0, [stdout], [stderr])
+AT_CHECK([fgrep "I detected 7 bonds in the molecule" stdout], 0, [ignore], [ignore])
+AT_CHECK([fgrep "CONECT" ethane.pdb], 0, [stdout], [ignore])
+AT_CHECK([fgrep "8" stdout], 0, [stdout], [ignore])
+
+file=ethane-half.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Graph/CreateAdjacency/pre/ethane.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -o pdb --select-atom-by-element 6 --create-adjacency], 0, [stdout], [stderr])
+AT_CHECK([fgrep "CONECT" ethane.pdb], 0, [stdout], [ignore])
+AT_CHECK([fgrep "1" stdout], 0, [stdout], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Graph - create adjacency with Undo])
+AT_KEYWORDS([graph create-adjacency undo])
+
+file=ethane.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Graph/CreateAdjacency/pre/ethane.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -o pdb --select-all-atoms --create-adjacency --undo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "I detected 7 bonds in the molecule" stdout], 0, [ignore], [ignore])
+AT_CHECK([fgrep "CONECT" ethane.pdb], 1, [ignore], [ignore])
+
+file=ethane-half.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Graph/CreateAdjacency/pre/ethane.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -o pdb --select-atom-by-element 6 --create-adjacency --undo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "CONECT" ethane.pdb], 1, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Graph - create adjacency with Redo])
+AT_KEYWORDS([graph create-adjacency redo])
+
+file=ethane.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Graph/CreateAdjacency/pre/ethane.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -o pdb --select-all-atoms --create-adjacency --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "I detected 7 bonds in the molecule" stdout], 0, [ignore], [ignore])
+AT_CHECK([fgrep "CONECT" ethane.pdb], 0, [stdout], [ignore])
+AT_CHECK([fgrep "8" stdout], 0, [stdout], [ignore])
+
+file=ethane-half.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Graph/CreateAdjacency/pre/ethane.xyz $file], 0)
+AT_CHECK([chmod u+w $file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder -i $file -o pdb --select-atom-by-element 6 --create-adjacency --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([fgrep "CONECT" ethane.pdb], 0, [stdout], [ignore])
+AT_CHECK([fgrep "1" stdout], 0, [stdout], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Graph/testsuite-graph.at
===================================================================
--- tests/regression/Graph/testsuite-graph.at	(revision 0d97b4b7169d73c32a31da6e1baa10b740848f7e)
+++ tests/regression/Graph/testsuite-graph.at	(revision 055ad7d1ba1b8d09c8c3cf8f1dfdf2b27859c787)
@@ -18,4 +18,7 @@
 AT_BANNER([MoleCuilder - Graph routines test])
 
+# create adjacency
+m4_include([Graph/CreateAdjacency/testsuite-graph-create-adjacency.at])
+
 # DFS analysis
 m4_include([Graph/DepthFirstSearch/testsuite-graph-depth-first-search.at])