Index: src/Actions/SelectionAction/Molecules/AllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/AllMoleculesAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/AllMoleculesAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define ALLMOLECULESSACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 
 #include "Actions/Action.hpp"
Index: src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/ClearAllMoleculesAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define CLEARALLMOLECULESSACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/MoleculeByFormulaAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define MOLECULEBYFORMULAACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/MoleculeByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByIdAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/MoleculeByIdAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define MOLECULEBYIDACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/MoleculeByNameAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByNameAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/MoleculeByNameAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define MOLECULEBYNAMEACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/MoleculeByOrderAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define MOLECULEBYORDERACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/MoleculeOfAtomAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define MOLECULEOFATOMSACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/NotAllMoleculesAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define NOTALLMOLECULESSACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define NOTMOLECULEBYFORMULAACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define NOTMOLECULEBYIDACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define NOTMOLECULEBYNAMEACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define NOTMOLECULEBYORDERACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 
Index: src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.hpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.hpp	(revision ad011c5ac0c9bfcf699f41ee11dd4a8aa0abb89a)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.hpp	(revision 56f73b5512dfb946d0cfe382fc8564d60e182c52)
@@ -9,4 +9,10 @@
 #define NOTMOLECULEOFATOMSACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
 #include "Actions/Action.hpp"
 